/***************************************************************************
                          dlgconnectinprogress.h  -  description                              
                             -------------------                                         
    begin                : Sat Dec 4 1999                                           
    copyright            : (C) 1999 by Seth Hartbecke                         
    email                : gandalf@netins.net                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef DLGCONNECTINPROGRESS_H
#define DLGCONNECTINPROGRESS_H

#include <qwidget.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qframe.h>
#include <qpushbutton.h>

#include <kapp.h>
#include <kiconloader.h>


/**
 * This object serves a very simple purpose...to intertain the
 * user while normal connect is in progres.
 *
 * Currently it is very simple, but some day some animations should
 * be added to it.
 *
 * @author Seth Hartbecke
 * @short Connect splash screen
 */

class DlgConnectInProgress
	: public QFrame
{
   Q_OBJECT
public:
	DlgConnectInProgress(QWidget *parent=0, const char *name=0);
	~DlgConnectInProgress();

        /**
         * Sets the text in the bottom part of the splash screen.
         */
	void setCaption(QString caption);
signals:
        /**
         * If the user presses the cancel button this signal is emitted.
         */
        void cancelConnect();

private:
	QGridLayout *topLayout;
	QWidget *konverseLogo;
	QLabel *connectMessage;
        QPushButton *cancel;
};

#endif
