/***************************************************************************
                          userlistmenu.h  -  description                              
                             -------------------                                         
    begin                : Sun Jan 9 2000                                           
    copyright            : (C) 2000 by Seth Hartbecke                         
    email                : gandalf@netins.net                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef USERLISTMENU_H
#define USERLISTMENU_H

#include <qwidget.h>
#include <qpopupmenu.h>
#include <qmap.h>

#include <jabbercore.h>
#include <useradd.h>

#include <user.h>

/**
  * A hack (though a cool one that I kinda like anymore).
  *
  * This is the menu that appears as a sub menu when you right click on the jabber icon in the tool tray.
  *
  * This menu is dynamically built and rebuilt....
  *
  * @author Seth Hartbecke
  *
  */

class UserListMenu : public QPopupMenu  {
   Q_OBJECT
public:
	UserListMenu(QWidget *parent=0, const char *name=0);
	~UserListMenu();
public slots:
	void addUser(User *u);
        void userInfoChanged(User *u);

private slots:
	void addNewUser();
        void presenceChanged(User *, UserPresence *);
        void removeUser( User * );

private:
        int nextMenuId;
        QMap <User *, int>userMenuIDmap;
};

#endif
